﻿using System;
using System.Data;
using System.Windows.Forms;
using Infragistics.Win.CalcEngine;
using Infragistics.Win.Misc;
using Infragistics.Win.UltraWinCalcManager;
using Infragistics.Win.UltraWinGrid;

namespace scratch_grid
{
    public partial class Form1 : Form
    {
        private UltraGrid grid1;
        private UltraGrid grid2;

        public Form1()
        {
            InitializeComponent();

            grid1 = CreateGrid(true);
            grid2 = CreateGrid(false);
            
            UltraButton btn = new UltraButton() { Dock = DockStyle.Top, Text = "Toggle" };
            Controls.Add(btn);
            btn.Click += (s, e) => {
                             ToggleValue(grid1);
                             ToggleValue(grid2);
                         };
        }

        private UltraGrid CreateGrid(bool setFormulaOnBoundColumn)
        {
            DataTable dt = new DataTable();
            dt.Columns.Add("col1", typeof(object));
            dt.Columns.Add("col2", typeof(object));
            dt.Rows.Add(new object[] { DBNull.Value, "" });

            UltraGrid grid = new UltraGrid { Name = "grid", Dock = DockStyle.Top };
            grid.CalcManager = new UltraCalcManager();
            Controls.Add(grid);
            
            grid.DataSource = dt;
            grid.Rows.Band.Columns.Add("unbound");
            grid.Rows.Band.Columns[1].CellActivation = Activation.NoEdit;
            if(setFormulaOnBoundColumn) {
                grid.Rows.Band.Columns[1].Formula = "IF([col1] = \"\", \"Blank\", \"Value\")";
            }
            grid.Rows.Band.Columns[2].Formula = "IF([col1] = \"\", \"Blank\", \"Value\")";
            return grid;
        }

        private void ToggleValue(UltraGrid grid)
        {
            var dt = (DataTable)grid.DataSource;
            dt.Rows[0][0] = dt.Rows[0][0] == DBNull.Value ? (object)1.0 : DBNull.Value;
        }
    }
}
